/**
 * Copyright (c) 2016-2018 Thales Global Services S.A.S.
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *   Abel Hegedus, Tamas Borbas, Balazs Grill, Peter Lunk, Daniel Segesdi (IncQuery Labs Ltd.) - initial API and implementation
 */
package org.eclipse.emf.diffmerge.patch.runtime;

import java.util.List;
import org.eclipse.emf.diffmerge.patch.api.BaseModelPatchMetadata;
import org.eclipse.xtend.lib.annotations.Accessors;
import org.eclipse.xtext.xbase.lib.CollectionLiterals;
import org.eclipse.xtext.xbase.lib.Pure;

@SuppressWarnings("all")
public class EMFModelPatchMetadata extends BaseModelPatchMetadata {
  @Accessors
  private List<String> modelUriList = CollectionLiterals.<String>newArrayList();
  
  @Accessors
  private List<String> usedNamespaceUris = CollectionLiterals.<String>newArrayList();
  
  @Pure
  public List<String> getModelUriList() {
    return this.modelUriList;
  }
  
  public void setModelUriList(final List<String> modelUriList) {
    this.modelUriList = modelUriList;
  }
  
  @Pure
  public List<String> getUsedNamespaceUris() {
    return this.usedNamespaceUris;
  }
  
  public void setUsedNamespaceUris(final List<String> usedNamespaceUris) {
    this.usedNamespaceUris = usedNamespaceUris;
  }
}
